// 002 u_load_package
// 10 mar 2007

// -- (C) John COLIBRI 2007
// -- documentation: http://www.jcolibri.com

(*$r+*)
unit u_load_package;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Mask;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    exit_: TButton;
    clear_: TButton;
    add_: TButton;
    one_edit_: TMaskEdit;
    lblPlus: TLabel;
    two_edit_: TMaskEdit;
    result_label_: TLabel;
    lblEquals: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure close_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure add_Click(Sender: TObject);
  private
  public
  end;

    var Form1: TForm1;

  implementation
    uses u_c_log, u_c_display, u_display_hex_2
    ;

    {$R *.DFM}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.close_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    const k_bpl_file_name= 'pk_add.bpl';
          k_one_plus_two= 'f_one_plus_two';
    type t_f_one_plus_two= function (p_one, p_two: Integer): integer; stdcall;

    procedure TForm1.add_Click(Sender: TObject);
      var l_package_handle: THandle;
          l_f_one_plus_two: t_f_one_plus_two;
          l_result: Integer;
          l_one, l_two: integer;
      begin
        display('> load_package');
        l_package_handle:= LoadPackage(k_bpl_file_name);
        display('handle '+ f_integer_to_hex(l_package_handle));

        try
          display('proc_ '+ k_one_plus_two);
          @l_f_one_plus_two:= GetProcAddress(l_package_handle, PChar(k_one_plus_two));
          display('ProcAddress '+ f_integer_to_hex(Integer(@l_f_one_plus_two)));


          if not (@l_f_one_plus_two= nil)
            then
              begin
                l_one:= StrToInt(one_edit_.Text);
                l_two:= StrToInt(two_edit_.Text);
                l_result:= l_f_one_plus_two(l_one, l_two);
                result_label_.Caption:= IntToStr(l_result);
              end;

        finally
        UnloadPackage(l_package_handle);
        end;

        display('< load_package');
      end; // add_Click
end.


